// I18N constants -- Japanese EUC-JP

// LANG: "ja-euc", ENCODING: EUC-JP
// Author: Mihai Bazon, http://dynarch.com/mishoo
// Translator:  
//   Manabu Onoue <tmocsys@tmocsys.com>, 2004.
//   Tadashi Jokagi <elf2000@users.sourceforge.net>, 2005.

HTMLArea.I18N = {

	// the following should be the filename without .js extension
	// it will be used for automatically load plugin language.
	lang: "ja-euc",

	tooltips: {
		bold:           "",
		italic:         "",
		underline:      "",
		strikethrough:  "Ǥä",
		subscript:      "դź",
		superscript:    "դź",
		justifyleft:    "",
		justifycenter:  "",
		justifyright:   "",
		justifyfull:    "",
		orderedlist:    "ֹդվ",
		unorderedlist:  "դվ",
		outdent:        "ǥȲ",
		indent:         "ǥ",
		forecolor:      "ʸ",
		hilitecolor:      "طʿ",
		horizontalrule: "ʿ",
		createlink:     "󥯺",
		insertimage:    "",
		inserttable:    "ơ֥",
		htmlmode:       "HTMLɽ",
		popupeditor:    "ǥ",
		about:          "С",
		showhelp:       "Help using editor",
		textindicator:  "ߤΥ",
		undo:           "Ǹä",
		redo:           "Ǹưľ",
		cut:            "ڤ",
		copy:           "򥳥ԡ",
		paste:          "åץܡɤŽդ",
		lefttoright:    "鱦",
		righttoleft:    "麸",
		removeformat:   "񼰤",
		print:          "ɥȤ",
		killword:       "MSOffice "
	},

	buttons: {
		"ok":           "OK",
		"cancel":       "ä"
	},

	msg: {
		"Path":         "ѥ",
		"TEXT_MODE":    "ƥȥ⡼ɤǤ[<>] ܥȤä WYSIWYG ޤ",

		"IE-sucks-full-screen" :
		// translate here
		"The full screen mode is known to cause problems with Internet Explorer, " +
		"due to browser bugs that we weren't able to workaround.  You might experience garbage " +
		"display, lack of editor functions and/or random browser crashes.  If your system is Windows 9x " +
		"it's very likely that you'll get a 'General Protection Fault' and need to reboot.\n\n" +
		"You have been warned.  Please press OK if you still want to try the full screen editor.",

		"Moz-Clipboard" :
		"Unprivileged scripts cannot access Cut/Copy/Paste programatically " +
		"for security reasons.  Click OK to see a technical note at mozilla.org " +
		"which shows you how to allow a script to access the clipboard."
	},

	dialogs: {
		// Common
		"OK"                                                : "OK",
		"Cancel"                                            : "ä",

		"Alignment:"                                        : "ֹ碌:",
		"Not set"                                           : "ꤷʤ",
		"Left"                                              : "",
		"Right"                                             : "",
		"Texttop"                                           : "Texttop",
		"Absmiddle"                                         : "Absmiddle",
		"Baseline"                                          : "١饤",
		"Absbottom"                                         : "Absbottom",
		"Bottom"                                            : "",
		"Middle"                                            : "",
		"Top"                                               : "",

		"Layout"                                            : "쥤",
		"Spacing"                                           : "ֳ",
		"Horizontal:"                                       : "ʿ:",
		"Horizontal padding"                                : "ʿη",
		"Vertical:"                                         : "ľ:",
		"Vertical padding"                                  : "ľη",
		"Border thickness:"                                 : ":",
		"Leave empty for no border"                         : "ʤˤ϶ˤޤ",

		// Insert Link
		"Insert/Modify Link"                                : "Insert/Modify Link",
		"None (use implicit)"                               : "ʤ (use implicit)",
		"New window (_blank)"                               : "ɥ (_blank)",
		"Same frame (_self)"                                : "Ʊե졼 (_self)",
		"Top frame (_top)"                                  : "Υե졼 (_top)",
		"Other"                                             : "¾",
		"Target:"                                           : "о:",
		"Title (tooltip):"                                  : "̾ (ġå):",
		"URL:"                                              : "URL:",
		"You must enter the URL where this link points to"  : "You must enter the URL where this link points to",
		// Insert Table
		"Insert Table"                                      : "ơ֥",
		"Rows:"                                             : ":",
		"Number of rows"                                    : "Կ",
		"Cols:"                                             : ":",
		"Number of columns"                                 : "",
		"Width:"                                            : ":",
		"Width of the table"                                : "ơ֥",
		"Percent"                                           : "ѡ",
		"Pixels"                                            : "ԥ",
		"Em"                                                : "Em",
		"Width unit"                                        : "ñ",
		"Positioning of this table"                         : "Υơ֥ΰ",
		"Cell spacing:"                                     : "δֳ:",
		"Space between adjacent cells"                      : "ܤδֳ",
		"Cell padding:"                                     : "η:",
		"Space between content and border in cell"          : "ζƤδֳ",
		// Insert Image
		"Insert Image"                                      : "",
		"Image URL:"                                        : " URL:",
		"Enter the image URL here"                          : "˲ URL ",
		"Preview"                                           : "ץӥ塼",
		"Preview the image in a new window"                 : "ɥǲץӥ塼",
		"Alternate text:"                                   : "ѥƥ:",
		"For browsers that don't support images"            : "򥵥ݡȤʤ֥饦Τ",
		"Positioning of this image"                         : "βΰ",
		"Image Preview:"                                    : "Υץӥ塼:"
	}
};
